//----------------------------------------------------------------------------
//
// Module : ServerDTImpl.java
//
// Description : classe ServerDTImpl
//
// Product : RemoteDesktop
//
// Author : Andrea.Musumeci@novara.alpcom.it
//
// Date  : dicembre, 1998
//
// Copyright : ISA Italian Software Agency SRL - freeware per usi non commerciali
//----------------------------------------------------------------------------

package com.isa.rmi.RemoteDesktop;

import java.net.URL;
import java.rmi.*;
import java.rmi.server.*;
import java.rmi.registry.LocateRegistry;
import java.rmi.server.UnicastRemoteObject;
import java.util.*;
import java.io.*;
import java.net.*;
import java.lang.*;


public class ServerDTImpl extends UnicastRemoteObject implements ServerDT, java.io.Serializable

{ 
 final String nameServerDT="RemoteDesktop";
 java.lang.Runtime rt;
 

 /***********/
 /* costruttore */
 /***********/

 public ServerDTImpl() throws java.rmi.RemoteException 
  {
  super();
  System.out.println("####################");
  System.out.println("RemoteDesktop started");
  rt = java.lang.Runtime.getRuntime();
  System.out.println("RemoteDesktop: runtime done");  
  }

public synchronized boolean execute (String command) throws java.rmi.RemoteException
 {
 try
  {
  System.out.println("RemoteDesktop: executing: "+command);
  rt.exec(command);
  } 
 catch (Exception e)
  {
  System.out.println("ServerDT: an exception occurred:");
  e.printStackTrace();
  return false;
  }
  return true;
 }

 /*******/
 /* main  */
 /*******/

 public static void main(String args[])
  {
   int port=1099;
  try
   {
    System.setSecurityManager(new RMISecurityManager());
    System.out.println("RemoteDesktop - version 1.0 - created by Andrea.Musumeci@novara.alpcom.it");
    System.out.println("RemoteDesktop.main: creating registry at port "+port);
    LocateRegistry.createRegistry(port);
    ServerDTImpl serverDT=new ServerDTImpl();
    System.out.println("RemoteDesktop.main: creating server");
    System.out.println("RemoteDesktop.main: binding server ");
    Naming.rebind("//:"+port+"/"+"RemoteDesktop", serverDT);
    System.out.println("RemoteDesktop.main: done");
   } 
   catch (Exception e)
    {
     System.out.println("RemoteDesktop: an exception occurred:");
     e.printStackTrace();
     System.exit(1);
    }
   }//fine main
   
}//fine class ServerDTImpl
